package ormsamples;

import java.util.Date;

import org.orm.PersistentException;
import org.orm.PersistentSession;
import org.orm.PersistentTransaction;

import com.vp.demo.Customer;
import com.vp.demo.CustomerFactory;
import com.vp.demo.Order;
import com.vp.demo.OrderFactory;
import com.vp.demo.OrderLine;
import com.vp.demo.OrmPersistentManager;

public class Create {
	public static void main(String[] args) {
		try {
			PersistentSession session = OrmPersistentManager.instance().getSession();
			Customer customer = CustomerFactory.createCustomer();
			customer.setAccountNo("C1232122");
			customer.save();
			for (int i = 0; i < 3000; i++) {
				Order order = OrderFactory.createOrder();
				order.setCustomer(customer);
				order.setOrderDate(new Date());
				order.setStatus(i % 2 == 0 ? Order.STATUS_OPEN : Order.STATUS_UNKNOWN);
				for (int j = 0; j < 10; j++) {
					OrderLine orderLine = new OrderLine();
					orderLine.setItemNo("I" + j);
					orderLine.setOrder(order);
					orderLine.setQuantity(j + 1);
				}
				order.save();
				session.flush();
				session.clear();
				System.out.println("Saved order: " + (i + 1));
			}
		} catch (PersistentException e) {
			e.printStackTrace();
		}
	}
}
