package ormsamples;

import org.hibernate.criterion.Projections;
import org.orm.PersistentException;

import com.vp.demo.CustomerCriteria;
import com.vp.demo.Order;
import com.vp.demo.OrderCriteria;
import com.vp.demo.OrderLine;
import com.vp.demo.OrderLineCriteria;
import com.vp.demo.OrmPersistentManager;

public class TestCriteria2 {
	public static void main(String[] args) {
		try {
			listDate();
		} catch (PersistentException e) {
			e.printStackTrace();
		}
	}

	private static void listDate() throws PersistentException {
		OrmPersistentManager.instance().getSession();
		long currentTimeMillis = System.currentTimeMillis();

		// create criteria class for orderline
		OrderLineCriteria criteria = new OrderLineCriteria();

		// create criteria class for order from criteria class of orderline
		OrderCriteria orderCriteria = criteria.createOrderCriteria();
		
		// specify criteria for looking up the orders
		orderCriteria.status.eq(Order.STATUS_OPEN);

		// create criteria class for customer from criteria class of order
		CustomerCriteria customerCriteria = orderCriteria.createCustomerCriteria();

		// specify criteria for looking up the customer
		customerCriteria.accountNo.eq("C1232122");

		// calculate total number of quantity
		criteria.setProjection(Projections.sum(OrderLine.PROP_QUANTITY));

		// execute query and obtain the result
		System.out.println(criteria.uniqueResult());
		System.out.println("Total ms: " + (System.currentTimeMillis() - currentTimeMillis));
	}
}
