package ormsamples;

import org.orm.PersistentException;

import com.vp.demo.Customer;
import com.vp.demo.CustomerFactory;
import com.vp.demo.Order;
import com.vp.demo.OrderLine;
import com.vp.demo.OrmPersistentManager;

public class TestNormal2 {

	public static void main(String[] args) {
		try {
			listDate();
		} catch (PersistentException e) {
			e.printStackTrace();
		}
	}

	private static void listDate() throws PersistentException {
		OrmPersistentManager.instance().getSession();
		long currentTimeMillis = System.currentTimeMillis();
		
		// query customer from database
		Customer[] customers = CustomerFactory.listCustomerByQuery(null, null);
		int qty = 0;

		// walk through the customer records
		for (int i = 0; i < customers.length; i++) {
			Customer customer = customers[i];
			if ("C1232122".equals(customer.getAccountNo())) {

				// query order records for the customer				
				Order[] orders = customer.orders.toArray();

				// walk through the order records
				for (int j = 0; j < orders.length; j++) {
					Order order = orders[j];
					
					// query only the order with open state
					if (Order.STATUS_OPEN == order.getStatus()) {

						// query the orderline records
						OrderLine[] orderlines = order.orderLines.toArray();

						// walk through the orderline records and calcualte the total quantity
						for (int k = 0; k < orderlines.length; k++) {
							OrderLine orderline = orderlines[k];
							qty += orderline.getQuantity();
						}
					}
				}				
			}
			break;
		}
		System.out.println("Total ms: " + (System.currentTimeMillis() - currentTimeMillis));
		System.out.println("Total Qty: " + qty);

		
	}
}
